IDValid proc		; TmpString on entry must contain the RSA ID String
	push ebx		; South-Africa has quite an elaborate way of validating
	lea esi, TmpString ; a 13 digit Personal Identification number
	xor eax, eax	   ; --> some sort of modulus hybrid
	xor ebx, ebx
	xor edx, edx
	mov ecx, 6
	cld
IDV1:	
	lodsb
	sub al, 48
	add bl, al
	lodsb
	sub al, 48
	shl al, 1
	cmp al, 9
	jbe IDV2
	sub al, 10
	inc al
IDV2:
	add dl, al
	dec ecx
	jnz IDV1
	mov eax, edx
	mov cl, 10
	mov dl, byte ptr [esi]
	add al, bl
	sub dl, 48
	div cl
	test ah, ah
	jnz IDV3 
	xor cl, cl
	inc al
IDV3:	
	sub cl, ah
	cmp dl, cl
	je IDV4 
	xor eax, eax
IDV4:	
	pop ebx
	ret
IDValid endp
IDDuplicate proc ;on entry TmpString  = RSA id String 13 digits
	invoke szLen, addr TmpString
	mov ecx, MemHandle
	mov edx, DB_END
	inc eax	
	.if ecx == edx ;if only one record = what are we doing here?, bye!
		mov eax, TRUE
		ret
	.endif	
	sub edx, ecx   ;else were looking at all records before this one 
	invoke BinSearch,NULL,MemHandle,edx,addr TmpString, eax
	.if eax != -1
		invoke RtlZeroMemory,[DB_END],512 ;clear record in memory we just added
		invoke MessageBox,hWnd,addr Error1b,addr ErrorA,MB_ICONEXCLAMATION
		mov eax, FALSE
	.else
		mov eax, TRUE		
	.endif
	ret
IDDuplicate endp
Update_ACC proc	; validate all user input 
	invoke MessageBox,hWnd,addr Error9a,addr ErrorA,MB_ICONEXCLAMATION or MB_OKCANCEL
	test eax, IDOK
	jnz	UAErr0
	ret
UAErr0:		
	mov ebx, cRecord
assume ebx : ptr ACC_STRUC	
	invoke GetDlgItemText,hWnd,1834,ADDR [ebx].A_Accnum , 10
	test eax, eax
	jz UAErr1
;-------------------------------------------------------------	
	invoke GetDlgItemText,hWnd,1816,ADDR [ebx].A_Surname, 30
	test eax, eax
	jz UAErr1
	invoke szLen, addr [ebx].A_Surname
	cmp eax, 3
	jl UAErr1
	invoke GetDlgItemText,hWnd,1817,ADDR [ebx].A_Name	, 30
	test eax, eax
	jz UAErr1	
	invoke szLen, addr [ebx].A_Name
	cmp eax, 3
	jl UAErr1
	invoke GetDlgItemText,hWnd,1818,ADDR [ebx].A_Addr1	, 30
	test eax, eax
	jz UAErr1
	invoke szLen, addr [ebx].A_Addr1
	cmp eax, 3
	jl UAErr1	
	invoke GetDlgItemText,hWnd,1819,ADDR [ebx].A_Addr2	, 30
	invoke GetDlgItemText,hWnd,1820,ADDR [ebx].A_Addr3	, 30
	invoke GetDlgItemText,hWnd,1821,ADDR [ebx].A_Suburb	, 30
	test eax, eax
	jz UAErr1	
	invoke szLen, addr [ebx].A_Suburb
	cmp eax, 3
	jl UAErr1
	invoke GetDlgItemText,hWnd,1822,ADDR [ebx].A_City	, 30
	test eax, eax
	jz UAErr1	
	invoke szLen, addr [ebx].A_City
	cmp eax, 3
	jl UAErr1
;-------------------------------------------------------------	 
	invoke GetDlgItemText,hWnd,1823,ADDR TmpString		, 15
;**************************************************************START [CUT]	
; Comment out or delete the following section if you get tired
; of South-African ID validation 
;--------------------------------------------------------------		
	invoke szLen, addr TmpString
	cmp eax, 13
	jl UAErr1
	call IDValid
;****************************************************************END [CUT]		
	test eax, eax
	jz UAErr1
	invoke szCopy, addr TmpString , addr [ebx].A_ID
	invoke GetDlgItemText,hWnd,1824,ADDR [ebx].A_TEL	, 15
	test eax, eax
	jz UAErr1
	invoke szLen, addr [ebx].A_TEL ; telephone number must be 10 digits
	cmp eax, 10
	jl UAErr1
	invoke GetDlgItemText,hWnd,1825,ADDR [ebx].A_CELL	, 15
	invoke GetDlgItemText,hWnd,1831,ADDR [ebx].A_Bank	, 30
	test eax, eax
	jz UAErr1	
	invoke szLen, addr [ebx].A_Bank
	cmp eax, 3
	jl UAErr1
	invoke GetDlgItemText,hWnd,1833,ADDR [ebx].A_Card	, 20
	test eax, eax
	jz UAErr1
	invoke szLen, addr [ebx].A_Card
	cmp eax, 5
	jl UAErr1
;-------------------------------------------------------------		 
	invoke GetDlgItemText,hWnd,1826,ADDR [ebx].A_Kin1	, 30
	test eax, eax
	jz UAErr1
	invoke szLen, addr [ebx].A_Kin1
	cmp eax, 3
	jl UAErr1
	invoke GetDlgItemText,hWnd,1827,ADDR [ebx].A_K1Tel	, 30
	test eax, eax
	jz UAErr1	
	invoke szLen, addr [ebx].A_K1Tel
	cmp eax, 3
	jl UAErr1
	invoke GetDlgItemText,hWnd,1828,ADDR [ebx].A_Kin2	, 30
	invoke GetDlgItemText,hWnd,1829,ADDR [ebx].A_K2Tel	, 30
	mov [ebx].A_Valid, 1234
	mov [ebx].A_End  , 13
	mov [ebx].A_End+1, 10 
assume ebx : NOTHING	
;-------------------------------------------------------------	
	.if ebx == DB_END
		call IDDuplicate  ; check for ID specific duplicate accounts 
		test eax, eax
		jz UAErr1
		xor eax, eax
		invoke atodw,addr B_accnum	; add 1 to account number
		inc eax
		invoke dw2a,eax, addr B_accnum
		call SaveBrnch
		inc S_newclient				; add 1 to new clients in this shift 
		call SetStock
	.endif
;-------------------------------------------------------------	
	invoke MessageBox,hWnd,addr Error2,addr ErrorA,MB_ICONINFORMATION
	invoke SendMessage,hWnd,WM_CLOSE,NULL,NULL
	mov IAccnt, TRUE
	ret	
UAErr1:
	invoke MessageBox,hWnd,addr Error1,addr ErrorA,MB_ICONSTOP
	ret
Update_ACC endp
AddAccount proc
	invoke MessageBox,hWnd,addr Error9,addr ErrorA,MB_ICONEXCLAMATION or MB_OKCANCEL
	test eax, IDOK
	jz	AA_Err1
	invoke szCopy  ,addr B_number , addr TmpString 
	invoke PadZero ,addr B_accnum , addr TmpString1 , 6
	invoke szCatStr,addr TmpString, addr TmpString1 
	invoke SetDlgItemText,hWnd,1834,ADDR TmpString
;-------------------------------------------------------------	
	invoke SetDlgItemText,hWnd,1816,NULL
	invoke SetDlgItemText,hWnd,1817,NULL	
	invoke SetDlgItemText,hWnd,1818,NULL
	invoke SetDlgItemText,hWnd,1819,NULL
	invoke SetDlgItemText,hWnd,1820,NULL
	invoke SetDlgItemText,hWnd,1821,NULL
	invoke SetDlgItemText,hWnd,1822,NULL
;-------------------------------------------------------------	 
	invoke SetDlgItemText,hWnd,1823,NULL
	invoke SetDlgItemText,hWnd,1824,NULL
	invoke SetDlgItemText,hWnd,1825,NULL
	invoke SetDlgItemText,hWnd,1831,NULL	
	invoke SetDlgItemText,hWnd,1833,NULL
;-------------------------------------------------------------		 
	invoke SetDlgItemText,hWnd,1826,NULL
	invoke SetDlgItemText,hWnd,1827,NULL	
	invoke SetDlgItemText,hWnd,1828,NULL
	invoke SetDlgItemText,hWnd,1829,NULL
;-------------------------------------------------------------
	push DB_END
	pop  cRecord
AA_Err1:		
	ret
AddAccount endp	
SetEInfo proc
	mov cRecord, ebx
assume ebx : ptr ACC_STRUC
	invoke SetDlgItemText,hWnd,1834,ADDR [ebx].A_Accnum
;-------------------------------------------------------------	
	invoke SetDlgItemText,hWnd,1816,ADDR [ebx].A_Surname
	invoke SetDlgItemText,hWnd,1817,ADDR [ebx].A_Name	
	invoke SetDlgItemText,hWnd,1818,ADDR [ebx].A_Addr1
	invoke SetDlgItemText,hWnd,1819,ADDR [ebx].A_Addr2
	invoke SetDlgItemText,hWnd,1820,ADDR [ebx].A_Addr3
	invoke SetDlgItemText,hWnd,1821,ADDR [ebx].A_Suburb
	invoke SetDlgItemText,hWnd,1822,ADDR [ebx].A_City
;-------------------------------------------------------------	 
	invoke SetDlgItemText,hWnd,1823,ADDR [ebx].A_ID
	invoke SetDlgItemText,hWnd,1824,ADDR [ebx].A_TEL
	invoke SetDlgItemText,hWnd,1825,ADDR [ebx].A_CELL
	invoke SetDlgItemText,hWnd,1831,ADDR [ebx].A_Bank	
	invoke SetDlgItemText,hWnd,1833,ADDR [ebx].A_Card
;-------------------------------------------------------------		 
	invoke SetDlgItemText,hWnd,1826,ADDR [ebx].A_Kin1
	invoke SetDlgItemText,hWnd,1827,ADDR [ebx].A_K1Tel	
	invoke SetDlgItemText,hWnd,1828,ADDR [ebx].A_Kin2
	invoke SetDlgItemText,hWnd,1829,ADDR [ebx].A_K2Tel
;-------------------------------------------------------------	
assume ebx : NOTHING	
	ret
SetEInfo endp
GetACCcount proc
	mov ebx, MemHandle 
	xor ecx, ecx	
	mov cRecord, ebx
assume ebx : ptr ACC_STRUC
GA_A:
	.if [ebx].A_Valid == 1234	; quick & simple integrity check
		inc ecx					; it was valid - yaah !- let's count it
		add ebx, 512			; step to next possible record
		jmp GA_A
	.endif	
assume ebx : NOTHING
	mov DB_END, ebx
	mov DB_REC, ecx	
	ret
GetACCcount endp
CloseMemMapAccFile proc
	invoke UnmapViewOfFile,MemHandle
	invoke CloseHandle,MemObject
	invoke CloseHandle,FileHandle1
	ret
CloseMemMapAccFile endp
OpenMemMapAccFile proc
LOCAL HighW : DWORD
	invoke CreateFile,ADDR Accfile,GENERIC_READ	or GENERIC_WRITE,
	NULL,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,FILE_FLAG_SEQUENTIAL_SCAN
	.if eax == INVALID_HANDLE_VALUE
		jmp OpenFail1
	.endif	
	mov FileHandle1, eax
	mov HighW, NULL
	invoke GetFileSize,FileHandle1,addr HighW
	.if eax == 0FFFFFFFFh || HighW != NULL
		jmp OpenFail2
	.endif
	;-----------------------------------------Set Initial Size
	.if eax < 51200			; if smaller than 512 * 100 transactions
		add eax, 51200      ; make space for 100 more transactions
	.endif
	;-----------------------------------------------------------------
	mov ebx, eax			; store current file size
	sub eax, DB_END			; current file size minus data chunk
	.if eax < 51200         ; if result less than 100 records
	    add ebx, 51200      ;        add 100 records
	.endif
	mov DB_SIZE, ebx
	;-----------------------------------------
	invoke CreateFileMapping,FileHandle1,NULL,PAGE_READWRITE,NULL,ebx,NULL
	mov MemObject, eax
	invoke MapViewOfFile,MemObject,FILE_MAP_WRITE,NULL,NULL,NULL 
	mov MemHandle, eax
	ret
OpenFail2:
	invoke CloseHandle,FileHandle1
OpenFail1:	
	invoke MessageBox,hWnd,addr Error8,addr ErrorA,MB_OK 
	mov eax, FALSE
	ret	
OpenMemMapAccFile endp
LoadAccnt proc
; Open the Account File and check for at least 1 account record
LOCAL TmpBuffer [512] : BYTE
	invoke CreateFile,ADDR Accfile,GENERIC_READ,
	NULL,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
	.if eax != INVALID_HANDLE_VALUE
		mov FileHandle, eax
		lea ebx, TmpBuffer 
		invoke ReadFile,FileHandle,ADDR TmpBuffer,512,ADDR ReadWrite,NULL
assume ebx : ptr ACC_STRUC		
		.if [ebx].A_Valid == 1234
			mov IAccnt, TRUE
		.endif
assume ebx : NOTHING			
		invoke CloseHandle,FileHandle	
	.endif	
	ret
LoadAccnt endp
EditProc	proc	hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL   scrBR   : SCROLLINFO
LOCAL	ps      : PAINTSTRUCT
LOCAL	hDCpic  : HDC	 
LOCAL	memDC   : DWORD 
   
	mov	eax,uMsg
	.if	eax==WM_INITDIALOG
		push hWin
		pop  hWnd
		.if B_shift == FALSE
			invoke MessageBox,hWnd,addr Error15,addr ErrorA,MB_ICONEXCLAMATION
			jmp EP_Exit
		.endif
		call OpenMemMapAccFile
		test eax, eax		; if false were in trouble
		jz EP_Exit
		call GetACCcount    ; count the number of accounts in file 
		mov ebx, MemHandle
	 	call SetEInfo
		invoke GetDlgItem,hWin,1838
	 	mov sScroll, eax
	 	invoke LoadBitmap,hInstance,302
		mov	RCBitmap1,eax
	 	mov ebx, DB_REC
	 	dec ebx
	 	mov scrBR.nMin  	, NULL		    ; minimum range for scroll
	 	mov scrBR.nPos  	, NULL			; start position
	 	mov scrBR.nTrackPos , NULL			; start track position 
	 	mov scrBR.nPage 	, TRUE			; maximum page size
	 	mov scrBR.nMax  	, ebx			; maximum range for scroll
	 	mov scrBR.fMask 	, SIF_ALL		; change all
		mov scrBR.cbSize, SIZEOF SCROLLINFO	; required 
		invoke SetScrollInfo,sScroll,SB_CTL,addr scrBR,TRUE
	.elseif eax==WM_CTLCOLORSTATIC 
			invoke GetDlgCtrlID,lParam
			.if eax==1801 || eax==1834 || eax==1840
				RGB 0,255,0
				invoke SetTextColor,wParam,eax
				invoke SetBkMode,wParam,TRANSPARENT	
				invoke GetStockObject,DKGRAY_BRUSH	
			.elseif eax==1837
				RGB 255,255,210
				invoke SetTextColor,wParam,eax
				invoke SetBkMode,wParam,TRANSPARENT	
				invoke GetStockObject,DKGRAY_BRUSH	
			.elseif eax==1805||eax==1806||eax==1811||eax==1814||eax==1815
				RGB 0,0,255
				invoke SetTextColor,wParam,eax
				invoke SetBkMode,wParam,TRANSPARENT	
				invoke GetStockObject,LTGRAY_BRUSH		
			.else
				mov eax,FALSE
			.endif	
			ret	
	 .elseif eax==WM_HSCROLL
   		invoke memfill,ADDR scrBR ,NULL ,SIZEOF SCROLLINFO
		mov scrBR.cbSize, SIZEOF SCROLLINFO
		mov scrBR.fMask, SIF_ALL
		invoke GetScrollInfo, lParam, SB_CTL, ADDR scrBR
		mov eax, wParam
		.if ax == SB_BOTTOM
			mov eax, scrBR.nMax
			mov scrBR.nPos, eax
			mov scrBR.nTrackPos, eax
		.elseif ax == SB_LINEDOWN
			inc scrBR.nPos
			inc scrBR.nTrackPos
		.elseif ax == SB_LINEUP
			dec scrBR.nPos
			dec scrBR.nTrackPos
		.elseif ax == SB_PAGEDOWN
			mov eax, scrBR.nPage
			add scrBR.nPos, eax
			add scrBR.nTrackPos, eax
		.elseif ax == SB_PAGEUP
			mov eax, scrBR.nPage
			sub scrBR.nPos, eax
			sub scrBR.nTrackPos, eax
		.elseif ax == SB_THUMBPOSITION
			mov eax, scrBR.nTrackPos
			mov scrBR.nPos, eax
		.elseif  ax == SB_THUMBTRACK
			mov eax, scrBR.nTrackPos
			mov scrBR.nPos, eax
		.elseif  ax == SB_TOP
			mov scrBR.nPos, NULL
			mov scrBR.nTrackPos, NULL
		.endif
		mov ebx, scrBR.nPos
		.if ebx >= 0 && ebx <= scrBR.nMax 
			mov scrBR.fMask, SIF_POS or SIF_TRACKPOS
			invoke SetScrollInfo, lParam, SB_CTL, ADDR scrBR, TRUE
			imul ebx, 512
			add ebx, MemHandle
			call SetEInfo
		.endif				
	.elseif	eax==WM_COMMAND
		mov edx,wParam
		movzx eax,dx
		shr edx,16
		.if edx==BN_CLICKED
			.if eax==1839		; ADD new ACCount
				call AddAccount
			.elseif eax==1835	; Submit or Re-Submit
				call Update_ACC	
			.elseif eax==1836	; Find Account by number/id
				invoke DialogBoxParam,hInstance,Find_Select,hWin,addr FindProc,NULL
				mov ebx, cRecord
				call SetEInfo
			.elseif eax==IDCANCEL
				invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif	
		.endif
	.elseif	eax==WM_PAINT
	    invoke BeginPaint,hWin,addr ps	 
	    mov		hDCpic,eax
	    invoke CreateCompatibleDC,hDCpic
	    mov		memDC,eax
	    invoke SelectObject,memDC, RCBitmap1   
	    invoke StretchBlt,hDCpic,278,4,87,196,memDC,0,0,88,196,SRCAND								
	    invoke EndPaint,hWin,addr ps	 		  
	    invoke DeleteDC,memDC					
	.elseif	eax==WM_CLOSE
		call CloseMemMapAccFile
		invoke DeleteObject,RCBitmap1
EP_Exit:		
		invoke	EndDialog,hWin,0
	.else
		xor eax, eax
		ret
	.endif		
	mov eax, TRUE
	ret	
EditProc endp