SaveStock proc
	invoke CreateFile,ADDR Stockfile,GENERIC_WRITE,
		NULL,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
	mov FileHandle, eax
	invoke WriteFile,FileHandle,ADDR S_Header,32,ADDR ReadWrite,NULL
    invoke CloseHandle,FileHandle
    mov IStock, TRUE
	ret
SaveStock endp
LoadStock proc
	invoke CreateFile,ADDR Stockfile,GENERIC_READ,
		NULL,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
	mov FileHandle, eax
	cmp eax, INVALID_HANDLE_VALUE
	je LS_Exit
	invoke ReadFile,FileHandle,ADDR S_Header,32,ADDR ReadWrite,NULL
    invoke CloseHandle,FileHandle
    mov IStock, TRUE
    ret
LS_Exit:
	mov IStock, FALSE    
	ret
LoadStock endp
SetLog proc
	invoke GetDateFormat,NULL,NULL,NULL,offset ADate,offset TmpString,10
	invoke GetTimeFormat,NULL,TIME_FORCE24HOURFORMAT,NULL,NULL,addr TTIME,12
	invoke szCatStr, addr LogItem, addr C_omma
	invoke szCatStr, addr LogItem, addr TmpString
	invoke szCatStr, addr LogItem, addr C_omma
	invoke szCatStr, addr LogItem, addr TTIME
	invoke szCatStr, addr LogItem, addr C_return
	invoke szLen, addr LogItem
	mov ebx, eax
	invoke CreateFile,ADDR Logfile,GENERIC_WRITE or GENERIC_READ,
		NULL,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
	mov FileHandle, eax	
	invoke SetFilePointer,FileHandle,NULL,NULL,FILE_END
	invoke WriteFile,FileHandle,ADDR LogItem,ebx,ADDR ReadWrite,NULL
    invoke CloseHandle,FileHandle
	ret
SetLog endp
SetStock proc
	call LoadStock
	.if IStock==TRUE
		invoke FpuFLtoA,ADDR S_value,2,ADDR TmpString,SRC1_REAL or SRC2_DIMM
		invoke SetDlgItemText,hWnd,1603,ADDR TmpString
		invoke SetDlgItemText,hWnd,1606,NULL
		invoke SetDlgItemText,hWnd,1608,NULL
	.endif
	ret
SetStock endp
GetStock proc
	invoke GetDlgItemText,hWnd,1606, ADDR TmpString, 50
	test eax, eax
	jz GS_Error1
	invoke FpuAtoFL, ADDR TmpString, ADDR TmpReal10, DEST_MEM
	test eax, eax
	jz GS_Error1
	invoke GetDlgItemText,hWnd,1608, ADDR TmpString1, 50
	test eax, eax
	jz GS_Error1
	.if ebx == TRUE ; IN request
		invoke szCopy  , addr TmpString, addr Error3A
		invoke szCatStr, addr Error3A  , addr Error3c
		invoke szCatStr, addr Error3A  , addr TmpString1
		invoke szCopy  , addr Error3x  , addr LogItem
		invoke MessageBox,hWnd,ADDR Error3a,ADDR ErrorA,MB_OKCANCEL	
		cmp eax, IDOK
		jne GS_Error2
		finit 
		fld TmpReal10
		fld S_value
		fadd
	.else			; OUT request
		invoke szCopy  , addr TmpString, addr Error3B
		invoke szCatStr, addr Error3B  , addr Error3c
		invoke szCatStr, addr Error3B  , addr TmpString1
		invoke szCopy  , addr Error3y  , addr LogItem
		invoke MessageBox,hWnd,ADDR Error3b,ADDR ErrorA,MB_OKCANCEL	
		cmp eax, IDOK
		jne GS_Error2
		finit 
		fld S_value
		fld TmpReal10
		fsub
	.endif
	fwait
	invoke FpuExam,NULL,SRC1_FPU ; is value Negative ?
	test eax, XAM_NEG
	jnz  GS_Error3
	fstp S_value
	call SaveStock
	call SetLog
	invoke MessageBox,hWnd,ADDR Error2,ADDR ErrorA,MB_ICONINFORMATION
	invoke	SendMessage,hWnd,WM_CLOSE,NULL,NULL
	ret
GS_Error1:
	invoke MessageBox,hWnd,ADDR Error1,ADDR ErrorA,MB_ICONSTOP
	ret	
GS_Error2:
	invoke MessageBox,hWnd,ADDR Error4,ADDR ErrorA,MB_ICONSTOP
	ret
GS_Error3:
	invoke MessageBox,hWnd,ADDR Error5,ADDR ErrorA,MB_ICONSTOP
	ret	
GetStock endp
StockProc	proc	hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov	eax,uMsg
	.if	eax==WM_INITDIALOG
		push hWin
		pop  hWnd
		invoke RtlZeroMemory,ADDR S_Header,32
		call SetStock
	.elseif eax==WM_CTLCOLORSTATIC 
			invoke GetDlgCtrlID,lParam
			.if eax==1601
				RGB 255,0,0
				invoke SetTextColor,wParam,eax
				invoke SetBkMode,wParam,TRANSPARENT	
				invoke GetStockObject,DKGRAY_BRUSH	
			.elseif eax==1603
				RGB 55,255,0
				invoke SetTextColor,wParam,eax
				invoke SetBkMode,wParam,TRANSPARENT	
				invoke GetStockObject,DKGRAY_BRUSH	
			.else
				mov eax,FALSE
			.endif	
			ret	
	.elseif	eax==WM_COMMAND
		mov edx,wParam
		movzx eax,dx
		shr edx,16
		.if edx==BN_CLICKED
			.if eax==1604 		; Stock to IN
				mov ebx, TRUE
				call GetStock
			.elseif eax==1602 	; Stock to OUT
				xor ebx, ebx
				call GetStock
			.elseif eax==IDCANCEL
				invoke	SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif	
		.endif
	.elseif	eax==WM_CLOSE
		invoke	EndDialog,hWin,0
	.else
		xor eax, eax
		ret
	.endif		
	mov eax, TRUE
	ret	
StockProc endp